#
# Conditional build:
%bcond_without	ocaml_opt	# native optimized binaries (bytecode is always built)

# not yet available on x32 (ocaml 4.02.1), update when upstream will support it
%ifnarch %{ix86} %{x8664} %{arm} aarch64 ppc sparc sparcv9
%undefine	with_ocaml_opt
%endif

Summary:	Cairo binding for OCaml
Summary(pl.UTF-8):	Wiązania Cairo dla OCamla
Name:		ocaml-cairo
Version:	1.2.0
Release:	11
License:	LGPL v2.1
Group:		Libraries
#Source0Download: http://cgit.freedesktop.org/cairo-ocaml/
Source0:	http://cgit.freedesktop.org/cairo-ocaml/snapshot/cairo-ocaml-%{version}.tar.bz2
# Source0-md5:	5d0096328f210a6ed032fec68e1bc141
Patch0:		%{name}-install.patch
# https://gitweb.gentoo.org/repo/gentoo.git/plain/dev-ml/cairo-ocaml/files/ocaml406.patch?id=05cb735234f0cb37b593d8cabf893bc4a8452cde
Patch1:		%{name}-ocaml406.patch
URL:		http://cairographics.org/cairo-ocaml/
BuildRequires:	autoconf >= 2.50
BuildRequires:	automake
BuildRequires:	cairo-devel >= 1.2.0
BuildRequires:	freetype-devel >= 2.0
BuildRequires:	gtk+2-devel >= 2:2.8
BuildRequires:	libsvg-cairo-devel
BuildRequires:	ocaml >= 3.04-7
BuildRequires:	ocaml-lablgtk2-devel
BuildRequires:	pkgconfig
%requires_eq	ocaml-runtime
Requires:	cairo >= 1.2.0
Requires:	ocaml-lablgtk2
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This package contains files needed to run OCaml bytecode executables
using Cairo library.

%description -l pl.UTF-8
Pakiet ten zawiera binaria potrzebne do uruchamiania programów w
OCamlu używających biblioteki Cairo.

%package devel
Summary:	Cairo binding for OCaml - development part
Summary(pl.UTF-8):	Wiązania Cairo dla OCamla - cześć programistyczna
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
%requires_eq	ocaml

%description devel
This package contains files needed to develop OCaml programs using
Cairo library.

%description devel -l pl.UTF-8
Pakiet ten zawiera pliki niezbędne do tworzenia programów używających
biblioteki Cairo.

%prep
%setup -q -n cairo-ocaml-%{version}
%patch0 -p1
%patch1 -p1

%build
%{__aclocal} -I support
%{__autoconf}
%configure

%{!?with_ocaml_opt:%{__sed} -i -e 's/OCAMLOPT .*=.*/OCAMLOPT=/' config.make}

%{__make} -j1 CC="%{__cc} %{rpmcflags} -fPIC" all
%{__make} -j1 doc

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

cp -r test/{Makefile,*.ml} $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

cat > $RPM_BUILD_ROOT%{_libdir}/ocaml/cairo/META <<EOF
requires = "bigarray"
version = "%{version}"
directory = "+cairo"
archive(byte) = "cairo.cma"
archive(native) = "cairo.cmxa"
linkopts = ""

package "lablgtk2" (
	requires = "cairo lablgtk2"
	archive(byte) = "cairo_lablgtk.cma"
	archive(native) = "cairo_lablgtk.cmxa"
)
EOF

# some distros include lablgtk2 subpackage for cairo, we used to provide cairo-lablgtk package
install -d $RPM_BUILD_ROOT%{_libdir}/ocaml/cairo-lablgtk
cat > $RPM_BUILD_ROOT%{_libdir}/ocaml/cairo-lablgtk/META <<EOF
requires = "cairo lablgtk2"
version = "%{version}"
directory = "+cairo"
archive(byte) = "cairo_lablgtk.cma"
archive(native) = "cairo_lablgtk.cmxa"
linkopts = ""
EOF

install -d $RPM_BUILD_ROOT%{_libdir}/ocaml/pangocairo
cat > $RPM_BUILD_ROOT%{_libdir}/ocaml/pangocairo/META <<EOF
requires = "cairo lablgtk2"
version = "%{version}"
directory = "+cairo"
archive(byte) = "pango_cairo.cma"
archive(native) = "pango_cairo.cmxa"
linkopts = ""
EOF

install -d $RPM_BUILD_ROOT%{_libdir}/ocaml/svgcairo
cat > $RPM_BUILD_ROOT%{_libdir}/ocaml/svgcairo/META <<EOF
requires = "cairo"
version = "%{version}"
directory = "+cairo"
archive(byte) = "svg_cairo.cma"
archive(native) = "svg_cairo.cmxa"
linkopts = ""
EOF

%{__rm} $RPM_BUILD_ROOT%{_libdir}/ocaml/cairo/*.mli

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc ChangeLog README
%dir %{_libdir}/ocaml/cairo
%{_libdir}/ocaml/cairo/META
%{_libdir}/ocaml/cairo/*.cma
%dir %{_libdir}/ocaml/cairo-lablgtk
%{_libdir}/ocaml/cairo-lablgtk/META
%dir %{_libdir}/ocaml/pangocairo
%{_libdir}/ocaml/pangocairo/META
%dir %{_libdir}/ocaml/svgcairo
%{_libdir}/ocaml/svgcairo/META
%attr(755,root,root) %{_libdir}/ocaml/stublibs/dllmlcairo.so
%attr(755,root,root) %{_libdir}/ocaml/stublibs/dllmlcairo_lablgtk.so
%attr(755,root,root) %{_libdir}/ocaml/stublibs/dllmlpangocairo.so
%attr(755,root,root) %{_libdir}/ocaml/stublibs/dllmlsvgcairo.so

%files devel
%defattr(644,root,root,755)
%doc doc/html src/*.mli
%{_libdir}/ocaml/cairo/*.cmi
%if %{with ocaml_opt}
%{_libdir}/ocaml/cairo/*.cmx
%{_libdir}/ocaml/cairo/*.cmxa
%{_libdir}/ocaml/cairo/cairo.a
%{_libdir}/ocaml/cairo/cairo_lablgtk.a
%{_libdir}/ocaml/cairo/pango_cairo.a
%{_libdir}/ocaml/cairo/svg_cairo.a
%endif
%{_libdir}/ocaml/cairo/libmlcairo.a
%{_libdir}/ocaml/cairo/libmlcairo_lablgtk.a
%{_libdir}/ocaml/cairo/libmlpangocairo.a
%{_libdir}/ocaml/cairo/libmlsvgcairo.a
%{_examplesdir}/%{name}-%{version}
%changelog
* Sun Sep 19 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ocaml-cairo.git;a=log;h=master

* Sat Sep 18 2021 Jakub Bogusz <qboosh@pld-linux.org> 4caffe4
- added ocaml406 patch from gentoo (fixes String vs Bytes issue)
- updated META files location
- release 11

* Mon Jun 05 2017 Jan Rękorajski <baggins@pld-linux.org> cac3a70
- rebuild with ocaml 4.04.1
- release 10 (by relup.sh)

* Mon Mar 21 2016 Jan Rękorajski <baggins@pld-linux.org> 530c853
- release 9 (by relup.sh)

* Sat Jul 18 2015 Jakub Bogusz <qboosh@pld-linux.org> 725d68e
- complete ocaml_opt archs list
- release 8 (ocaml rebuild)

* Mon Apr 06 2015 Jan Rękorajski <baggins@pld-linux.org> b311e41
- added ocaml_opt bcond
- rel 7

* Sun Nov 16 2014 Jan Rękorajski <baggins@pld-linux.org> f5c17a9
- rebuild with ocaml 4.02
- release 6 (by relup.sh)

* Tue Oct 29 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 61fe099
- release 5 (by relup.sh)

* Sun Feb 12 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> befc909
- release 4

* Tue Feb 07 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 0689306
- release 3

* Tue Dec 20 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> c6fa68c
- release 2

* Wed Dec 07 2011 Jakub Bogusz <qboosh@pld-linux.org> afe294a
- typo

* Wed Dec 07 2011 Jakub Bogusz <qboosh@pld-linux.org> 30aaa0b
- cairo module requires bigarray
- added pangocairo META file
- provide cairo.lablgtk2 also as subpackage in cairo META file (following Debian and few others)

* Tue Dec 06 2011 Jakub Bogusz <qboosh@pld-linux.org> 6546515
- updated to 1.2.0 release

* Thu May 17 2007 Jakub Bogusz <qboosh@pld-linux.org> 3f7953b
- BR: pkgconfig

* Sun Apr 15 2007 Jakub Bogusz <qboosh@pld-linux.org> 5a28ff9
- complete descs, gtk+2 epoch

* Wed Apr 11 2007 Jan Rękorajski <baggins@pld-linux.org> e71d825
- install libs in proper dir

* Wed Apr 11 2007 Jan Rękorajski <baggins@pld-linux.org> b34ed9b
- finished

* Wed Apr 11 2007 Jan Rękorajski <baggins@pld-linux.org> 941caa2
- initial revision, WIP

